diff --git a/arch/arm/mach-omap2/pm34xx.c b/arch/arm/mach-omap2/pm34xx.c
index 7a4a525..0545262 100644
--- a/arch/arm/mach-omap2/pm34xx.c
+++ b/arch/arm/mach-omap2/pm34xx.c
@@ -200,91 +200,110 @@ static irqreturn_t prcm_interrupt_handler (int irq, void *dev_id)
 	u32 wkst, irqstatus_mpu;
 	u32 fclk, iclk;
 
-	/* WKUP */
-	wkst = prm_read_mod_reg(WKUP_MOD, PM_WKST);
-	if (wkst) {
-		iclk = cm_read_mod_reg(WKUP_MOD, CM_ICLKEN);
-		fclk = cm_read_mod_reg(WKUP_MOD, CM_FCLKEN);
-		cm_set_mod_reg_bits(wkst, WKUP_MOD, CM_ICLKEN);
-		cm_set_mod_reg_bits(wkst, WKUP_MOD, CM_FCLKEN);
-		prm_write_mod_reg(wkst, WKUP_MOD, PM_WKST);
-		while (prm_read_mod_reg(WKUP_MOD, PM_WKST))
-			cpu_relax();
-		cm_write_mod_reg(iclk, WKUP_MOD, CM_ICLKEN);
-		cm_write_mod_reg(fclk, WKUP_MOD, CM_FCLKEN);
-	}
-
-	/* CORE */
-	wkst = prm_read_mod_reg(CORE_MOD, PM_WKST1);
-	if (wkst) {
-		iclk = cm_read_mod_reg(CORE_MOD, CM_ICLKEN1);
-		fclk = cm_read_mod_reg(CORE_MOD, CM_FCLKEN1);
-		cm_set_mod_reg_bits(wkst, CORE_MOD, CM_ICLKEN1);
-		cm_set_mod_reg_bits(wkst, CORE_MOD, CM_FCLKEN1);
-		prm_write_mod_reg(wkst, CORE_MOD, PM_WKST1);
-		while (prm_read_mod_reg(CORE_MOD, PM_WKST1))
-			cpu_relax();
-		cm_write_mod_reg(iclk, CORE_MOD, CM_ICLKEN1);
-		cm_write_mod_reg(fclk, CORE_MOD, CM_FCLKEN1);
-	}
-	wkst = prm_read_mod_reg(CORE_MOD, OMAP3430ES2_PM_WKST3);
-	if (wkst) {
-		iclk = cm_read_mod_reg(CORE_MOD, CM_ICLKEN3);
-		fclk = cm_read_mod_reg(CORE_MOD, OMAP3430ES2_CM_FCLKEN3);
-		cm_set_mod_reg_bits(wkst, CORE_MOD, CM_ICLKEN3);
-		cm_set_mod_reg_bits(wkst, CORE_MOD, OMAP3430ES2_CM_FCLKEN3);
-		prm_write_mod_reg(wkst, CORE_MOD, OMAP3430ES2_PM_WKST3);
-		while (prm_read_mod_reg(CORE_MOD, OMAP3430ES2_PM_WKST3))
-			cpu_relax();
-		cm_write_mod_reg(iclk, CORE_MOD, CM_ICLKEN3);
-		cm_write_mod_reg(fclk, CORE_MOD, OMAP3430ES2_CM_FCLKEN3);
-	}
+	do {
+		/* WKUP */
+		wkst = prm_read_mod_reg(WKUP_MOD, PM_WKST);
+		if (wkst) {
+			iclk = cm_read_mod_reg(WKUP_MOD, CM_ICLKEN);
+			fclk = cm_read_mod_reg(WKUP_MOD, CM_FCLKEN);
+			while (wkst) {
+				cm_set_mod_reg_bits(wkst, WKUP_MOD, CM_ICLKEN);
+				cm_set_mod_reg_bits(wkst, WKUP_MOD, CM_FCLKEN);
+				prm_write_mod_reg(wkst, WKUP_MOD, PM_WKST);
+				wkst = prm_read_mod_reg(WKUP_MOD, PM_WKST);
+			}
+			cm_write_mod_reg(iclk, WKUP_MOD, CM_ICLKEN);
+			cm_write_mod_reg(fclk, WKUP_MOD, CM_FCLKEN);
+		}
 
-	/* PER */
-	wkst = prm_read_mod_reg(OMAP3430_PER_MOD, PM_WKST);
-	if (wkst) {
-		iclk = cm_read_mod_reg(OMAP3430_PER_MOD, CM_ICLKEN);
-		fclk = cm_read_mod_reg(OMAP3430_PER_MOD, CM_FCLKEN);
-		cm_set_mod_reg_bits(wkst, OMAP3430_PER_MOD, CM_ICLKEN);
-		cm_set_mod_reg_bits(wkst, OMAP3430_PER_MOD, CM_FCLKEN);
-		prm_write_mod_reg(wkst, OMAP3430_PER_MOD, PM_WKST);
-		while (prm_read_mod_reg(OMAP3430_PER_MOD, PM_WKST))
-			cpu_relax();
-		cm_write_mod_reg(iclk, OMAP3430_PER_MOD, CM_ICLKEN);
-		cm_write_mod_reg(fclk, OMAP3430_PER_MOD, CM_FCLKEN);
-	}
+		/* CORE */
+		wkst = prm_read_mod_reg(CORE_MOD, PM_WKST1);
+		if (wkst) {
+			iclk = cm_read_mod_reg(CORE_MOD, CM_ICLKEN1);
+			fclk = cm_read_mod_reg(CORE_MOD, CM_FCLKEN1);
+			while (wkst) {
+				cm_set_mod_reg_bits(wkst, CORE_MOD, CM_ICLKEN1);
+				cm_set_mod_reg_bits(wkst, CORE_MOD, CM_FCLKEN1);
+				prm_write_mod_reg(wkst, CORE_MOD, PM_WKST1);
+				wkst = prm_read_mod_reg(CORE_MOD, PM_WKST1);
+			}
+			cm_write_mod_reg(iclk, CORE_MOD, CM_ICLKEN1);
+			cm_write_mod_reg(fclk, CORE_MOD, CM_FCLKEN1);
+		}
+		wkst = prm_read_mod_reg(CORE_MOD, OMAP3430ES2_PM_WKST3);
+		if (wkst) {
+			iclk = cm_read_mod_reg(CORE_MOD, CM_ICLKEN3);
+			fclk = cm_read_mod_reg(CORE_MOD,
+						OMAP3430ES2_CM_FCLKEN3);
+			while (wkst) {
+				cm_set_mod_reg_bits(wkst, CORE_MOD, CM_ICLKEN3);
+				cm_set_mod_reg_bits(wkst, CORE_MOD,
+							OMAP3430ES2_CM_FCLKEN3);
+				prm_write_mod_reg(wkst, CORE_MOD,
+							OMAP3430ES2_PM_WKST3);
+				wkst = prm_read_mod_reg(CORE_MOD,
+							OMAP3430ES2_PM_WKST3);
+			}
+			cm_write_mod_reg(iclk, CORE_MOD, CM_ICLKEN3);
+			cm_write_mod_reg(fclk, CORE_MOD,
+						OMAP3430ES2_CM_FCLKEN3);
+		}
 
-	if (omap_rev() > OMAP3430_REV_ES1_0) {
-		/* USBHOST */
-		wkst = prm_read_mod_reg(OMAP3430ES2_USBHOST_MOD, PM_WKST);
+		/* PER */
+		wkst = prm_read_mod_reg(OMAP3430_PER_MOD, PM_WKST);
 		if (wkst) {
-			iclk = cm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
+			iclk = cm_read_mod_reg(OMAP3430_PER_MOD, CM_ICLKEN);
+			fclk = cm_read_mod_reg(OMAP3430_PER_MOD, CM_FCLKEN);
+			while (wkst) {
+				cm_set_mod_reg_bits(wkst, OMAP3430_PER_MOD,
+							CM_ICLKEN);
+				cm_set_mod_reg_bits(wkst, OMAP3430_PER_MOD,
+							CM_FCLKEN);
+				prm_write_mod_reg(wkst, OMAP3430_PER_MOD,
+							PM_WKST);
+				wkst = prm_read_mod_reg(OMAP3430_PER_MOD,
+							PM_WKST);
+			}
+			cm_write_mod_reg(iclk, OMAP3430_PER_MOD, CM_ICLKEN);
+			cm_write_mod_reg(fclk, OMAP3430_PER_MOD, CM_FCLKEN);
+		}
+
+		if (omap_rev() > OMAP3430_REV_ES1_0) {
+			/* USBHOST */
+			wkst = prm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
+							PM_WKST);
+			if (wkst) {
+				iclk = cm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
 					       CM_ICLKEN);
-			fclk = cm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
+				fclk = cm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
 					       CM_FCLKEN);
-			cm_set_mod_reg_bits(wkst, OMAP3430ES2_USBHOST_MOD,
-					    CM_ICLKEN);
-			cm_set_mod_reg_bits(wkst, OMAP3430ES2_USBHOST_MOD,
-					    CM_FCLKEN);
-			prm_write_mod_reg(wkst, OMAP3430ES2_USBHOST_MOD,
-					  PM_WKST);
-			while (prm_read_mod_reg(OMAP3430ES2_USBHOST_MOD,
-						PM_WKST))
-				cpu_relax();
-			cm_write_mod_reg(iclk, OMAP3430ES2_USBHOST_MOD,
+				while (wkst) {
+					cm_set_mod_reg_bits(wkst,
+							OMAP3430ES2_USBHOST_MOD,
+							CM_ICLKEN);
+					cm_set_mod_reg_bits(wkst,
+							OMAP3430ES2_USBHOST_MOD,
+							CM_FCLKEN);
+					prm_write_mod_reg(wkst,
+							OMAP3430ES2_USBHOST_MOD,
+							PM_WKST);
+					wkst = prm_read_mod_reg(
+							OMAP3430ES2_USBHOST_MOD,
+							PM_WKST);
+				}
+				cm_write_mod_reg(iclk, OMAP3430ES2_USBHOST_MOD,
 					 CM_ICLKEN);
-			cm_write_mod_reg(fclk, OMAP3430ES2_USBHOST_MOD,
+				cm_write_mod_reg(fclk, OMAP3430ES2_USBHOST_MOD,
 					 CM_FCLKEN);
+			}
 		}
-	}
 
-	irqstatus_mpu = prm_read_mod_reg(OCP_MOD,
-					 OMAP3_PRM_IRQSTATUS_MPU_OFFSET);
-	prm_write_mod_reg(irqstatus_mpu, OCP_MOD,
-			  OMAP3_PRM_IRQSTATUS_MPU_OFFSET);
+		irqstatus_mpu = prm_read_mod_reg(OCP_MOD,
+					OMAP3_PRM_IRQSTATUS_MPU_OFFSET);
+		prm_write_mod_reg(irqstatus_mpu, OCP_MOD,
+					OMAP3_PRM_IRQSTATUS_MPU_OFFSET);
 
-	while (prm_read_mod_reg(OCP_MOD, OMAP3_PRM_IRQSTATUS_MPU_OFFSET))
-		cpu_relax();
+	} while (prm_read_mod_reg(OCP_MOD, OMAP3_PRM_IRQSTATUS_MPU_OFFSET));
 
 	return IRQ_HANDLED;
 }